#ifndef _EDITWING_COMMON_H_
#define _EDITWING_COMMON_H_
#include "../kilib/kilib.h"
#ifndef __ccdoc__
namespace editwing {
#endif



//=========================================================================
//@{ @pkg editwing.Common //@}
//@{
//	eLXg̈ʒu
//@}
//=========================================================================

struct DPos : public ki::Object
{
	//@{ obt@̃AhX (0` ) //@}
	ulong ad;

	//@{ _sԍ (0` ) //@}
	ulong tl;

	bool operator == ( const DPos& r ) const
		{ return (tl==r.tl && ad==r.ad); }
	bool operator != ( const DPos& r ) const
		{ return (tl!=r.tl || ad!=r.ad); }
	bool operator <  ( const DPos& r ) const
		{ return (tl<r.tl || (tl==r.tl && ad<r.ad)); }
	bool operator >  ( const DPos& r ) const
		{ return (tl>r.tl || (tl==r.tl && ad>r.ad)); }
	bool operator <= ( const DPos& r ) const
		{ return (tl<r.tl || (tl==r.tl && ad<=r.ad)); }
	bool operator >= ( const DPos& r ) const
		{ return (tl>r.tl || (tl==r.tl && ad>=r.ad)); }

	DPos( ulong t, ulong a ) : tl(t), ad(a) {}
	DPos() {}
};



//=========================================================================
//@{
//	ꕶ\萔l
//@}
//=========================================================================

enum SpecialChars
{
	scEOF = 0, // EOF
	scEOL = 1, // s
	scTAB = 2, // ^u
	scHSP = 3, // pXy[X
	scZSP = 4  // SpXy[X
};



//=========================================================================
//@{
//	P̎ނ\萔l
//@}
//=========================================================================

enum TokenType
{
	TAB = 0x00, // Tab
	WSP = 0x04, // pXy[X
	ALP = 0x08, // ʂ̎
	 CE = 0x0c, // RgI^O
	 CB = 0x10, // RgJn^O
	 LB = 0x14, // sRgJn^O
	 Q1 = 0x18, // Pp
	 Q2 = 0x1c  // dp
};



//=========================================================================
//@{
//	Fwӏ\萔l
//@}
//=========================================================================

enum ColorType
{
	TXT = 0, // F
	CMT = 1, // RgF
	KWD = 2, // L[[hF
	//  = 3, // ( RgAEgꂽL[[hF )
	CTL = 4, // ꕶF
	BG  = 5  // wiF
};



//=========================================================================
//@{
//	܂Ԃʒu萔l
//@}
//=========================================================================

enum WrapType
{
	NOWRAP    = -1, // ܂Ԃ
	RIGHTEDGE =  0  // E[
};



//=========================================================================
//@{
//	\ݒ
//
//	tHgEFE^uEꕶ̕\ȀێB
//	AP̎w Document ɑ΂čsB
//@}
//=========================================================================

struct VConfig : public ki::Object
{
	//@{ tHg //@}
	LOGFONT font;
	int fontsize;

	//@{ ^u //@}
	int tabstep;

	//@{ F //@}
	COLORREF color[6];

	//@{ ꕶ\ //@}
	bool sc[5];

	//@{ 댯ȃftHgRXgN^ //@}
	VConfig() {}

	//@{ tHg֌W //@}
	VConfig( const TCHAR* fnam, int fsiz )
	{
		SetFont( fnam,fsiz );
		tabstep    = 4;
		color[TXT] =
		color[CMT] =
		color[KWD] =
		color[CTL] = RGB(0,0,0);
		color[ BG] = RGB(255,255,255);
		sc[scEOF]  =
		sc[scEOL]  =
		sc[scTAB]  =
		sc[scHSP]  =
		sc[scZSP]  = false;
	}

	//@{ tHg֌Wݒ //@}
	void SetFont( const TCHAR* fnam, int fsiz )
	{
		fontsize              = fsiz;
		font.lfWidth          = 0;
		font.lfEscapement     = 0;
		font.lfOrientation    = 0;
		font.lfWeight         = FW_DONTCARE;
		font.lfItalic         = FALSE;
		font.lfUnderline      = FALSE;
		font.lfStrikeOut      = FALSE;
		font.lfOutPrecision   = OUT_DEFAULT_PRECIS;
		font.lfClipPrecision  = CLIP_DEFAULT_PRECIS;
		font.lfQuality        = DEFAULT_QUALITY;
		font.lfPitchAndFamily = VARIABLE_PITCH|FF_DONTCARE;
		font.lfCharSet        = DEFAULT_CHARSET;

		::lstrcpy( font.lfFaceName, fnam );

		HDC h = ::GetDC( NULL );
		font.lfHeight = -MulDiv(fsiz, ::GetDeviceCaps(h,LOGPIXELSY), 72);
		::ReleaseDC( NULL, h );
	}

	//@{ ^uݒ //@}
	void SetTabStep( int tab )
	{
		tabstep = Max( 1, tab );
	}
};



//=========================================================================

}      // namespace editwing
#endif // _EDITWING_COMMON_H_
