#ifndef _EDITWING_IP_DOC_H_
#define _EDITWING_IP_DOC_H_
#include "ewDoc.h"
using namespace ki;
#ifndef __ccdoc__
namespace editwing {
namespace doc {
#endif



//@{ @pkg editwing.Doc.Impl //@}
class Parser;



//=========================================================================
//@{
//	sobt@\
//
//	UCS-2x^̌`ŃeLXgf[^ێB܂ƓɁA
//	L[[ht@CɂĎw肳ꂽʂ邽߂
//	͏ʗpobt@ǗBf[^ɏI[NUL
//	tȂA͍Ƃ̍̂߁AI[ U+007f B
//@}
//=========================================================================

class Line : public Object
{
public:

	//@{ weLXgŏ //@}
	Line( const unicode* str, ulong len )
		: alen_( 10>len ? 10 : len )
		, len_ ( len )
		, flg_ ( static_cast<uchar*>(mem().Alloc( alen_+(alen_+1)*2) ) )
		, str_ ( reinterpret_cast<unicode*>( flg_+alen_ ) )
		, commentBitReady_( false )
		, isLineHeadCommented_( 0 )
		{
			memcpy( str_, str, len*2 );
			str_[ len ] = 0x007f;
		}

	~Line()
		{
			mem().DeAlloc( flg_, alen_+(alen_+1)*2 );
		}

	//@{ eLXg}(wʒuɎwTCY) //@}
	void InsertAt( ulong at, const unicode* buf, ulong siz )
		{
			if( len_+siz > alen_ )
			{
				// obt@g
				ulong psiz = alen_+(alen_+1)*2;
				alen_ = Max( alen_<<1, len_+siz );
				uchar*   tmpF =
					static_cast<uchar*>(mem().Alloc( alen_+(alen_+1)*2) );
				unicode* tmpS =
					reinterpret_cast<unicode*>(tmpF+alen_);
				// Rs[
				memcpy( tmpS,        str_,             at*2 );
				memcpy( tmpS+at+siz, str_+at, (len_-at+1)*2 );
				memcpy( tmpF,        flg_,             at   );
				// Â̂폜
				mem().DeAlloc( flg_, psiz );
				str_ = tmpS;
				flg_ = tmpF;
			}
			else
			{
				memmove( str_+at+siz, str_+at, (len_-at+1)*2 );
				memmove( flg_+at+siz, flg_+at, (len_-at)     );
			}
			memcpy( str_+at, buf, siz*sizeof(unicode) );
			len_ += siz;
		}

	//@{ eLXg}() //@}
	void InsertToTail( const unicode* buf, ulong siz )
		{
			InsertAt( len_, buf, siz );
		}

	//@{ eLXg폜(wʒuwTCY) //@}
	void RemoveAt( ulong at, ulong siz )
		{
			memmove( str_+at, str_+at+siz, (len_-siz-at+1)*2 );
			memmove( flg_+at, flg_+at+siz, (len_-siz-at)     );
			len_ -= siz;
		}

	//@{ eLXg폜(wʒu疖܂) //@}
	void RemoveToTail( ulong at )
		{
			if( at < len_ )
				str_[ len_=at ] = 0x007f;
		}

	//@{ obt@ɃRs[(wʒuwTCY) //@}
	ulong CopyAt( ulong at, ulong siz, unicode* buf )
		{
			memcpy( buf, str_+at, siz*sizeof(unicode) );
			return siz;
		}

	//@{ obt@ɃRs[(wʒu疖܂) //@}
	ulong CopyToTail( ulong at, unicode* buf )
		{
			return CopyAt( at, len_-at, buf );
		}

	//@{  //@}
	ulong size() const
		{ return len_; }

	//@{ eLXg //@}
	unicode* str()
		{ return str_; }

	//@{ eLXg(const) //@}
	const unicode* str() const
		{ return str_; }

	//@{ ͌ //@}
	uchar* flg()
		{ return flg_; }

	//@{ ͌(const) //@}
	const uchar* flg() const
		{ return flg_; }

	// ask
	bool isCmtBitReady() const
		{ return commentBitReady_; }
	uchar isLineHeadCmt() const
		{ return isLineHeadCommented_; }
	// for doc
	uchar TransitCmt( uchar start )
		{
			isLineHeadCommented_ = start;
			commentBitReady_     = false;
			return (commentTransition_>>start)&1;
		}
	// for parser
	void SetTransitFlag( uchar flag )
		{ commentTransition_ = flag; }
	void CommentBitUpdated()
		{ commentBitReady_   = true; }

private:
	ulong    alen_;
	ulong    len_;
	uchar*   flg_;
	unicode* str_;

	uchar isLineHeadCommented_;
	uchar commentTransition_;
	bool  commentBitReady_;
};



//=========================================================================
//@{
//	UnicodeeLXg؂蕪N
//
//	sPʂŏsƂ̂ŁA̍sɕ鏈
//	؂oBgetLine() 邽тɁAw肵|C^Ɛϐ
//	擪珇ɍs̃f[^i[čsB
//@}
//=========================================================================

class UniReader
{
public:

	//@{ ǂ݂Ƃ茳obt@^ď //@}
	UniReader(
		const unicode*     str, ulong     len,
		const unicode** ansstr, ulong* anslen )
		: ptr_  ( str )
		, end_  ( str+len )
		, ans_  ( ansstr )
		, aln_  ( anslen )
		, empty_( false ) {}

	//@{ ǂݏIǂ`FbN //@}
	bool isEmpty()
		{ return empty_; }

	//@{ s擾 //@}
	void getLine()
		{
			// ̉s̈ʒu擾
			const unicode *p=ptr_, *e=end_;
			for( ; p<e; ++p )
				if( *p == L'\r' || *p == L'\n' )
					break;
			// L^
			*ans_  = ptr_;
			*aln_  = p-ptr_;
			// sR[hXLbv
			if( p == e )
				empty_ = true;
			else
				if( *(p++)==L'\r'&& p<e && *p==L'\n' )
					++p;
			ptr_  = p;
		}

private:
	bool  empty_;
	const unicode *ptr_, *end_, **ans_;
	ulong *aln_;
};



//=========================================================================
//@{
//	Undo/RedopɁACommandIuWFNgۑĂNX
//@}
//=========================================================================

class UnReDoChain : public Object
{
public:

	//@{ RXgN^ //@}
	UnReDoChain();

	//@{ fXgN^ //@}
	~UnReDoChain();

	//@{ Undos //@}
	void Undo( Document& doc );

	//@{ Redos //@}
	void Redo( Document& doc );

	//@{ VR}hs //@}
	void NewlyExec( Command& cmd, Document& doc );

	//@{ Ԃɖ߂ //@}
	void Clear();

	//@{ ۑʒutO݈ʒuɃZbg //@}
	void SavedHere();

	//@{ Undo/Redỏ񐔐wB-1 = Infinite //@}
	void SetLimit( long lim );

public:

	//@{ Undo삪\H //@}
	bool isUndoAble() const;

	//@{ Redo삪\H //@}
	bool isRedoAble() const;

	//@{ ۑAύXĂ邩H //@}
	bool isModified() const;

private:

	struct Node : public Object
	{
		Node();
		Node( Command*, Node*, Node* );
		~Node();
		void  ResetCommand( Command* cmd );
		ulong ChainDelete();
		Node    *next_, *prev_;
		Command *cmd_;
	};

private:

	Node  headTail_;
	Node* savedPos_;
	Node* lastOp_;
	ulong num_;
	ulong limit_;

private:

	NOCOPY(UnReDoChain);
};



//-------------------------------------------------------------------------
#ifndef __ccdoc__

inline void UnReDoChain::SavedHere()
	{ savedPos_ = lastOp_; }

inline bool UnReDoChain::isUndoAble() const
	{ return (lastOp_ != &headTail_); }

inline bool UnReDoChain::isRedoAble() const
	{ return (lastOp_->next_ != &headTail_); }

inline bool UnReDoChain::isModified() const
	{ return (lastOp_ != savedPos_); }



#endif // __ccdoc__
//=========================================================================
//@{
//	DocumentNX̎
//@}
//=========================================================================

class DocImpl : public Object
{
public:

	DocImpl( Document& theDoc );
	~DocImpl();

	//@{ R}hs //@}
	void Execute( Command& cmd );

	//@{ L[[h`؂ւ //@}
	void SetKeyword( const unicode* defbuf, ulong siz );

	//@{ Cxgnho^ //@}
	void AddHandler( DocEvHandler* eh );

	//@{ Cxgnh //@}
	void DelHandler( DocEvHandler* eh );

	//@{ t@CJ //@}
	void OpenFile( aptr<TextFileR> tf );

	//@{ t@Cۑ //@}
	void SaveFile( TextFileW& tf );

	//@{ ej //@}
	void ClearAll();

	//@{ AhD //@]
	void Undo();

	//@{ hD //@]
	void Redo();

	//@{ AhD񐔐 //@]
	void SetUndoLimit( long lim );

	//@{ ύXtONA //@}
	void ClearModifyFlag();

public:

	//@{ s //@}
	ulong tln() const;

	//@{ sobt@ //@}
	const unicode* tl( ulong i ) const;

	//@{ s͌ʃobt@ //@}
	const uchar* pl( ulong i ) const;

	//@{ s //@}
	ulong len( ulong i ) const;

	//@{ w͈͂̃eLXg̒ //@}
	ulong getRangeLength( const DPos& stt, const DPos& end );

	//@{ w͈͂̃eLXg //@}
	void getText( unicode* buf, const DPos& stt, const DPos& end );

	//@{ wʒu̒P̐擪擾 //@}
	DPos wordStartOf( const DPos& dp ) const;

	//@{ wʒü̈ʒu擾 //@}
	DPos leftOf( const DPos& dp, bool wide=false ) const;

	//@{ wʒüËʒu擾 //@}
	DPos rightOf( const DPos& dp, bool wide=false ) const;

	//@{ AhD\H //@}
	bool isUndoAble() const;

	//@{ hD\H //@}
	bool isRedoAble() const;

	//@{ ύXς݁H //@}
	bool isModified() const;

private:

	Document&                      doc_;    // 
	dptr<Parser>                   parser_; // ͖
	gapbufobj<Line>                text_;   // eLXgf[^
	mutable storage<DocEvHandler*> pEvHan_; // Cxgʒm
	UnReDoChain                    urdo_;   // AhDhD

private:

	// ύXʒm
	void Fire_KEYWORDCHANGE();
	void Fire_MODIFYFLAGCHANGE();
	void Fire_TEXTUPDATE( const DPos& s,
		const DPos& e, const DPos& e2, bool reparsed, bool nmlcmd );

	// wp[֐
	bool ReParse( ulong s, ulong e );
	void SetCommentBit( const Line& x ) const;
	void CorrectPos( DPos& pos );
	void CorrectPos( DPos& stt, DPos& end );

	// }E폜
	bool InsertingOperation(
		DPos& stt, const unicode* str, ulong len, DPos& undoend );
	bool DeletingOperation(
		DPos& stt, DPos& end, unicode*& undobuf, ulong& undosiz );

private:

	NOCOPY(DocImpl);
	friend class Insert;
	friend class Delete;
	friend class Replace;
};



//-------------------------------------------------------------------------

inline ulong DocImpl::tln() const
	{ return text_.size(); }

inline const unicode* DocImpl::tl( ulong i ) const
	{ return text_[i].str(); }

inline ulong DocImpl::len( ulong i ) const
	{ return text_[i].size(); }

inline const uchar* DocImpl::pl( ulong i ) const
	{
		const Line& x = text_[i];
		if( !x.isCmtBitReady() )
			SetCommentBit( x );
		return x.flg();
	}



//=========================================================================

}}     // namespace editwing::doc
#endif // _EDITWING_IP_DOC_H_
