#ifndef _KILIB_REGISTRY_H_
#define _KILIB_REGISTRY_H_
#include "types.h"
#include "memory.h"
#include "path.h"
#ifndef __ccdoc__
namespace ki {
#endif


	
//=========================================================================
//@{ @pkg ki.WinUtil //@}
//@{
//	INIt@Cǂݍ
//
//@}
//=========================================================================

class IniFile : public Object
{
public:

	//@{ RXgN^ //@}
	IniFile( const TCHAR* ini=NULL, bool exeppath=true );

	//@{ init@Cݒ //@}
	void SetFileName( const TCHAR* ini=NULL, bool exepath=true );

	//@{ ZNVݒ //@}
	void SetSection( const TCHAR* section );

	//@{ ZNV[U[ɐݒ //@}
	void SetSectionAsUserName();

	//@{ lǂݍ //@}
	int    GetInt ( const TCHAR* key, int   defval ) const;
	//@{ ^Ulǂݍ //@}
	bool   GetBool( const TCHAR* key, bool  defval ) const;
	//@{ ǂݍ //@}
	String GetStr ( const TCHAR* key, const String& defval ) const;

	//@{ l //@}
	bool PutStr ( const TCHAR* key, const TCHAR* val );
	//@{ ^Ul //@}
	bool PutInt ( const TCHAR* key, int val );
	//@{ 񏑂 //@}
	bool PutBool( const TCHAR* key, bool val );

private:

	Path   iniName_;
	String section_;
	char m_StrBuf[256];
};



//-------------------------------------------------------------------------

inline IniFile::IniFile( const TCHAR* ini, bool exepath )
	{ SetFileName( ini, exepath ); }

inline void IniFile::SetSection( const TCHAR* section )
	{ section_ = section; }




//=========================================================================

}      // namespace ki
#endif // _KILIB_REGISTRY_H_
