#ifndef _KILIB_THREAD_H_
#define _KILIB_THREAD_H_
#include "types.h"
#ifndef __ccdoc__
namespace ki {
#endif



//=========================================================================
//@{ @pkg ki.Core //@}
//@{
//	}`Xbh̊Ǘ
//
//	܂܂
//@}
//=========================================================================


class ThreadManager
{
public:
//	void Run( Runnable& r );
	bool isMT();

private:

	ThreadManager();

private:

	int threadNum_;
	static ThreadManager* pUniqueInstance_;

private:

	friend void APIENTRY Startup();
	friend inline ThreadManager& thd();
	NOCOPY(ThreadManager);
};



//-------------------------------------------------------------------------

//@{ B̃XbhǗIuWFNgԂ //@}
inline ThreadManager& thd()
	{ return *ThreadManager::pUniqueInstance_; }

inline bool ThreadManager::isMT()
	{ return 0 != threadNum_; }



//=========================================================================
//@{
//	}`XbhE|V[P
//
//	̃NXhƁAAutoLock NXg悤ɂȂ܂B
//	̃NX this |C^nƂŔrԂɓAfXgN^
//	o悤ɂȂ܂BNoLockable::AutoLock ͎ۂ͉܂B
//@}
//=========================================================================

class NoLockable
{
protected:
	struct AutoLock
	{
		AutoLock( NoLockable* host ) {}
	};
};



//=========================================================================
//@{
//	}`XbhE|V[Q
//
//	̃NXhƁAAutoLock NXg悤ɂȂ܂B
//	̃NX this |C^nƂŔrԂɓAfXgN^
//	o悤ɂȂ܂BEzLockable::AutoLock ́AVOXbh
//	삷ƂقƂǂƂAvP[VɁA
//	sSȔrs܂BQ{ڂ̃Xbhグ̏uԂȂB
//@}
//=========================================================================

class EzLockable
{
protected:
	EzLockable()
		{ ::InitializeCriticalSection( &csection_ ); }
	~EzLockable()
		{ ::DeleteCriticalSection( &csection_ ); }

	struct AutoLock
	{
		AutoLock( EzLockable* host )
		{
			if( NULL != (pCs_=(thd().isMT() ? &host->csection_ : NULL)) )
				::EnterCriticalSection( pCs_ );
		}
		~AutoLock()
		{
			if( pCs_ )
				::LeaveCriticalSection( pCs_ );
		}
	private:
		NOCOPY(AutoLock);
	    CRITICAL_SECTION* pCs_;
	};

private:
	CRITICAL_SECTION csection_;
	friend struct AutoLock;
};



//=========================================================================
//@{
//	}`XbhE|V[R
//
//	̃NXhƁAAutoLock NXg悤ɂȂ܂B
//	̃NX this |C^nƂŔrԂɓAfXgN^
//	o悤ɂȂ܂BLockable::AutoLock ́ASȔr
//	s܂BSȂ炩Ȃ炸̃NXp܂傤B
//@}
//=========================================================================

class Lockable
{
protected:
	Lockable()
		{ ::InitializeCriticalSection( &csection_ ); }
	~Lockable()
		{ ::DeleteCriticalSection( &csection_ ); }

	struct AutoLock
	{
		AutoLock( Lockable* host )
		{
			pCs_ = &host->csection_;
			::EnterCriticalSection( pCs_ );
		}
		~AutoLock()
		{
			::LeaveCriticalSection( pCs_ );
		}
	private:
		NOCOPY(AutoLock);
	    CRITICAL_SECTION* pCs_;
	};

private:
	CRITICAL_SECTION csection_;
	friend struct AutoLock;
};



//=========================================================================

}      // namespace ki
#endif // _KILIB_THREAD_H_
